using cuqmbr.TravelGuide.Application.Common.Models;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Aircrafts.Queries.GetAircraftsPage;

public record GetAircraftsPageQuery : IRequest<PaginatedList<AircraftDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string Search { get; set; } = String.Empty;

    public string Sort { get; set; } = String.Empty;

    public Guid? CompanyGuid { get; set; }

    public short? CapacityGreaterThanOrEqualTo { get; set; }

    public short? CapacityLessThanOrEqualTo { get; set; }
}
