using cuqmbr.TravelGuide.Application.Common.Persistence.Repositories;

namespace cuqmbr.TravelGuide.Application.Common.Persistence;

public interface UnitOfWork : IDisposable
{
    // Application Logic

    CountryRepository CountryRepository { get; }

    RegionRepository RegionRepository { get; }

    CityRepository CityRepository { get; }

    AddressRepository AddressRepository { get; }

    RouteRepository RouteRepository { get; }

    VehicleRepository VehicleRepository { get; }

    BusRepository BusRepository { get; }

    AircraftRepository AircraftRepository { get; }

    TrainRepository TrainRepository { get; }

    VehicleEnrollmentRepository VehicleEnrollmentRepository { get; }

    RouteAddressRepository RouteAddressRepository { get; }

    CompanyRepository CompanyRepository { get; }

    EmployeeRepository EmployeeRepository { get; }

    TicketGroupRepository TicketGroupRepository { get; }

    TicketRepository TicketRepository { get; }

    RouteAddressDetailRepository RouteAddressDetailRepository { get; }

    VehicleEnrollmentEmployeeRepository VehicleEnrollmentEmployeeRepository { get; }

    // Identity

    AccountRepository AccountRepository { get; }

    RoleRepository RoleRepository { get; }

    AccountRoleRepository AccountRoleRepository { get; }

    RefreshTokenRepository RefreshTokenRepository { get; }

    int Save();

    Task<int> SaveAsync(CancellationToken cancellationToken);
}
