using cuqmbr.TravelGuide.Domain.Entities;
using cuqmbr.TravelGuide.Application.Common.Mappings;

namespace cuqmbr.TravelGuide.Application.Identity.Accounts;

public sealed class AccountDto : IMapFrom<Account>
{
    public Guid Uuid { get; set; }

    public string Username { get; set; }

    public string Email { get; set; }

    public ICollection<string> Roles { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<Account, AccountDto>()
            .ForMember(
                d => d.Uuid,
                opt => opt.MapFrom(s => s.Guid))
            .ForMember(
                d => d.Roles,
                opt => opt.MapFrom(s =>
                    s.AccountRoles.Select(ar => ar.Role.Value.Name)));
    }
}
