using cuqmbr.TravelGuide.Application.Common.Models;
using MediatR;

namespace cuqmbr.TravelGuide.Application.Trains.Queries.GetTrainsPage;

public record GetTrainsPageQuery : IRequest<PaginatedList<TrainDto>>
{
    public int PageNumber { get; set; } = 1;

    public int PageSize { get; set; } = 10;

    public string Search { get; set; } = String.Empty;

    public string Sort { get; set; } = String.Empty;

    public Guid? CompanyGuid { get; set; }

    public short? CapacityGreaterOrEqualThan { get; set; }

    public short? CapacityLessOrEqualThan { get; set; }
}
