using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.Trains;

public sealed class TrainDto : IMapFrom<Train>
{
    public Guid Uuid { get; set; }

    public string Number { get; set; }

    public string Model { get; set; }

    public short Capacity { get; set; }

    public Guid CompanyUuid { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<Train, TrainDto>()
            .ForMember(
                d => d.Uuid,
                opt => opt.MapFrom(s => s.Guid))
            .ForMember(
                d => d.CompanyUuid,
                opt => opt.MapFrom(s => s.Company.Guid));
    }
}
