using cuqmbr.TravelGuide.Application.VehicleEnrollments.Models;
using cuqmbr.TravelGuide.Domain.Enums;
using MediatR;

namespace cuqmbr.TravelGuide.Application.VehicleEnrollments
    .Commands.UpdateVehicleEnrollment;

public record UpdateVehicleEnrollmentCommand : IRequest<VehicleEnrollmentDto>
{
    public Guid Guid { get; set; }

    public DateTimeOffset DepartureTime { get; set; }

    public Currency Currency { get; set; }


    public ICollection<RouteAddressDetailModel> RouteAddressDetails { get; set; }

    public ICollection<Guid> EmployeeGuids { get; set; }
}
