using cuqmbr.TravelGuide.Application.Common.Mappings;
using cuqmbr.TravelGuide.Domain.Entities;

namespace cuqmbr.TravelGuide.Application.VehicleEnrollments;

public sealed class RouteAddressDetailDto : IMapFrom<RouteAddressDetail>
{
    public TimeSpan TimeToNextAddress { get; set; }

    public decimal CostToNextAddress { get; set; }

    public TimeSpan CurrentAddressStopTime { get; set; }

    public Guid RouteAddressUuid { get; set; }


    public VehicleEnrollmentRouteAddressDto RouteAddress { get; set; }

    public void Mapping(MappingProfile profile)
    {
        profile.CreateMap<RouteAddressDetail, RouteAddressDetailDto>()
            .ForMember(
                d => d.RouteAddressUuid,
                opt => opt.MapFrom(s => s.RouteAddress.Guid))
            .ForMember(
                d => d.RouteAddress,
                opt => opt.MapFrom(s => s.RouteAddress));
    }
}
