using cuqmbr.TravelGuide.Infrastructure.Services;
using cuqmbr.TravelGuide.Application.Common.Services;
using Microsoft.Extensions.DependencyInjection;

namespace cuqmbr.TravelGuide.Configuration.Infrastructure;

public static class Configuration
{
    public static IServiceCollection ConfigureInfrastructure(
        this IServiceCollection services)
    {
        services
            .AddHttpClient();

        services
            .AddScoped<
                PasswordHasherService,
                Pbkdf2PasswordHasherService>()
            .AddScoped<
                CurrencyConverterService,
                ExchangeApiCurrencyConverterService>()
            .AddScoped<
                cuqmbr.TravelGuide.Application.Common.Services.LiqPayPaymentService,
                cuqmbr.TravelGuide.Infrastructure.Services.LiqPayPaymentService>();

        return services;
    }
}
