namespace cuqmbr.TravelGuide.Domain.Entities;

public class RefreshToken : EntityBase
{
    public string Value { get; set; } = null!;

    public DateTimeOffset CreationTime { get; set; }

    public DateTimeOffset ExpirationTime { get; set; }

    public DateTimeOffset? RevocationTime { get; set; }

    public bool IsExpired => DateTimeOffset.UtcNow >= ExpirationTime;

    public bool IsActive => RevocationTime == null && !IsExpired;

    public long AccountId { get; set; }

    public Account Account { get; set; }
}
