namespace cuqmbr.TravelGuide.Domain.Enums;

// Do not forget to update the schema of your database when changing
// this class (if you use it with a database)

// ISO-4217 Currency Codes dated 2025-03-31

public abstract class Currency : Enumeration<Currency>
{
    public static readonly Currency Default = new DefaultCurrency();
    public static readonly Currency USD = new USDCurrency();
    public static readonly Currency EUR = new EURCurrency();
    public static readonly Currency UAH = new UAHCurrency();

    protected Currency(int value, string name) : base(value, name) { }

    // When no currency is specified
    private sealed class DefaultCurrency : Currency
    {
        public DefaultCurrency() : base(Int32.MaxValue, "DEFAULT") { }
    }

    private sealed class USDCurrency : Currency
    {
        public USDCurrency() : base(840, "USD") { }
    }

    private sealed class EURCurrency : Currency
    {
        public EURCurrency() : base(978, "EUR") { }
    }

    private sealed class UAHCurrency : Currency
    {
        public UAHCurrency() : base(980, "UAH") { }
    }
}
