namespace cuqmbr.TravelGuide.Domain.Enums;

public abstract class IdentityRole : Enumeration<IdentityRole>
{
    public static readonly IdentityRole Administrator = new AdministratorRole();
    public static readonly IdentityRole User = new UserRole();
    public static readonly IdentityRole CompanyOwner = new CompanyOwnerRole();
    public static readonly IdentityRole CompanyEmployee = new CompanyEmployeeRole();

    protected IdentityRole(int value, string name) : base(value, name) { }

    private sealed class AdministratorRole : IdentityRole
    {
        public AdministratorRole() : base(0, "administrator") { }
    }

    private sealed class UserRole : IdentityRole
    {
        public UserRole() : base(1, "user") { }
    }

    private sealed class CompanyOwnerRole : IdentityRole
    {
        public CompanyOwnerRole() : base(2, "company_owner") { }
    }

    private sealed class CompanyEmployeeRole : IdentityRole
    {
        public CompanyEmployeeRole() : base(3, "company_employee") { }
    }
}
