namespace cuqmbr.TravelGuide.Domain.Enums;

public abstract class TicketStatus : Enumeration<TicketStatus>
{
    public static readonly TicketStatus Reserved = new ReservedTicketStatus();
    public static readonly TicketStatus Returned = new ReturnedTicketStatus();
    public static readonly TicketStatus Purchased = new PurchasedTicketStatus();

    protected TicketStatus(int value, string name) : base(value, name) { }

    private sealed class ReservedTicketStatus : TicketStatus
    {
        public ReservedTicketStatus() : base(0, "reserved") { }
    }

    private sealed class ReturnedTicketStatus : TicketStatus
    {
        public ReturnedTicketStatus() : base(1, "returned") { }
    }

    private sealed class PurchasedTicketStatus : TicketStatus
    {
        public PurchasedTicketStatus() : base(2, "purchased") { }
    }
}
