using Microsoft.AspNetCore.Mvc;
using cuqmbr.TravelGuide.Application.Authenticaion;
using cuqmbr.TravelGuide.Application.Authenticaion.Queries.Login;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands.Register;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands.RenewAccessToken;
using cuqmbr.TravelGuide.Application.Authenticaion.Commands.RevokeRefreshToken;

namespace cuqmbr.TravelGuide.HttpApi.Controllers;

[Route("authentication")]
public class AuthenticationController : ControllerBase
{
    [HttpPost("register")]
    public async Task Register(
        [FromBody] RegisterCommand command,
        CancellationToken cancellationToken)
    {
        await Mediator.Send(command, cancellationToken);
    }

    [HttpPost("login")]
    public async Task<TokensModel> Login(
        [FromBody] LoginQuery query,
        CancellationToken cancellationToken)
    {
        return await Mediator.Send(query, cancellationToken);
    }

    [HttpPost("renewAccessToken")]
    public async Task<TokensModel> RenewAccessToken(
        [FromBody] RenewAccessTokenCommand command,
        CancellationToken cancellationToken)
    {
        return await Mediator.Send(command, cancellationToken);
    }

    [HttpPost("revokeRefreshToken")]
    public async Task RevokeRefreshToken(
        [FromBody] RevokeRefreshTokenCommand command,
        CancellationToken cancellationToken)
    {
        await Mediator.Send(command, cancellationToken);
    }
}
