﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Remove_duplicate_indices_on_pk_and_altk : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropUniqueConstraint(
                name: "altk_routes_Guid",
                schema: "application",
                table: "routes");

            migrationBuilder.DropIndex(
                name: "ix_routes_id",
                schema: "application",
                table: "routes");

            migrationBuilder.DropIndex(
                name: "ix_routes_uuid",
                schema: "application",
                table: "routes");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_route_addresses_Guid",
                schema: "application",
                table: "route_addresses");

            migrationBuilder.DropIndex(
                name: "ix_route_addresses_id",
                schema: "application",
                table: "route_addresses");

            migrationBuilder.DropIndex(
                name: "ix_route_addresses_uuid",
                schema: "application",
                table: "route_addresses");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_regions_Guid",
                schema: "application",
                table: "regions");

            migrationBuilder.DropIndex(
                name: "ix_regions_id",
                schema: "application",
                table: "regions");

            migrationBuilder.DropIndex(
                name: "ix_regions_uuid",
                schema: "application",
                table: "regions");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_countries_Guid",
                schema: "application",
                table: "countries");

            migrationBuilder.DropIndex(
                name: "ix_countries_id",
                schema: "application",
                table: "countries");

            migrationBuilder.DropIndex(
                name: "ix_countries_uuid",
                schema: "application",
                table: "countries");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_cities_Guid",
                schema: "application",
                table: "cities");

            migrationBuilder.DropIndex(
                name: "ix_cities_id",
                schema: "application",
                table: "cities");

            migrationBuilder.DropIndex(
                name: "ix_cities_uuid",
                schema: "application",
                table: "cities");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_addresses_Guid",
                schema: "application",
                table: "addresses");

            migrationBuilder.DropIndex(
                name: "ix_addresses_id",
                schema: "application",
                table: "addresses");

            migrationBuilder.DropIndex(
                name: "ix_addresses_uuid",
                schema: "application",
                table: "addresses");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_routes_uuid",
                schema: "application",
                table: "routes",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_route_addresses_uuid",
                schema: "application",
                table: "route_addresses",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_regions_uuid",
                schema: "application",
                table: "regions",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_countries_uuid",
                schema: "application",
                table: "countries",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_cities_uuid",
                schema: "application",
                table: "cities",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_addresses_uuid",
                schema: "application",
                table: "addresses",
                column: "uuid");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropUniqueConstraint(
                name: "altk_routes_uuid",
                schema: "application",
                table: "routes");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_route_addresses_uuid",
                schema: "application",
                table: "route_addresses");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_regions_uuid",
                schema: "application",
                table: "regions");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_countries_uuid",
                schema: "application",
                table: "countries");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_cities_uuid",
                schema: "application",
                table: "cities");

            migrationBuilder.DropUniqueConstraint(
                name: "altk_addresses_uuid",
                schema: "application",
                table: "addresses");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_routes_Guid",
                schema: "application",
                table: "routes",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_route_addresses_Guid",
                schema: "application",
                table: "route_addresses",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_regions_Guid",
                schema: "application",
                table: "regions",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_countries_Guid",
                schema: "application",
                table: "countries",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_cities_Guid",
                schema: "application",
                table: "cities",
                column: "uuid");

            migrationBuilder.AddUniqueConstraint(
                name: "altk_addresses_Guid",
                schema: "application",
                table: "addresses",
                column: "uuid");

            migrationBuilder.CreateIndex(
                name: "ix_routes_id",
                schema: "application",
                table: "routes",
                column: "id",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_routes_uuid",
                schema: "application",
                table: "routes",
                column: "uuid",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_route_addresses_id",
                schema: "application",
                table: "route_addresses",
                column: "id",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_route_addresses_uuid",
                schema: "application",
                table: "route_addresses",
                column: "uuid",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_regions_id",
                schema: "application",
                table: "regions",
                column: "id",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_regions_uuid",
                schema: "application",
                table: "regions",
                column: "uuid",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_countries_id",
                schema: "application",
                table: "countries",
                column: "id",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_countries_uuid",
                schema: "application",
                table: "countries",
                column: "uuid",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_cities_id",
                schema: "application",
                table: "cities",
                column: "id",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_cities_uuid",
                schema: "application",
                table: "cities",
                column: "uuid",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_addresses_id",
                schema: "application",
                table: "addresses",
                column: "id",
                unique: true);

            migrationBuilder.CreateIndex(
                name: "ix_addresses_uuid",
                schema: "application",
                table: "addresses",
                column: "uuid",
                unique: true);
        }
    }
}
