﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using cuqmbr.TravelGuide.Persistence.PostgreSql;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    [DbContext(typeof(PostgreSqlDbContext))]
    [Migration("20250515101417_Add_Companies")]
    partial class Add_Companies
    {
        /// <inheritdoc />
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasDefaultSchema("application")
                .HasAnnotation("ProductVersion", "9.0.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.HasSequence("addresses_id_sequence");

            modelBuilder.HasSequence("cities_id_sequence");

            modelBuilder.HasSequence("companies_id_sequence");

            modelBuilder.HasSequence("countries_id_sequence");

            modelBuilder.HasSequence("regions_id_sequence");

            modelBuilder.HasSequence("route_address_details_id_sequence");

            modelBuilder.HasSequence("route_addresses_id_sequence");

            modelBuilder.HasSequence("routes_id_sequence");

            modelBuilder.HasSequence("vehicle_enrollments_id_sequence");

            modelBuilder.HasSequence("vehicles_id_sequence");

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.addresses_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "addresses_id_sequence");

                    b.Property<long>("CityId")
                        .HasColumnType("bigint")
                        .HasColumnName("city_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<double>("Latitude")
                        .HasColumnType("double precision");

                    b.Property<double>("Longitude")
                        .HasColumnType("double precision");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(128)")
                        .HasColumnName("name");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasColumnType("varchar(16)")
                        .HasColumnName("vehicle_type");

                    b.HasKey("Id")
                        .HasName("pk_addresses");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_addresses_uuid");

                    b.HasIndex("CityId")
                        .HasDatabaseName("ix_addresses_city_id");

                    b.ToTable("addresses", "application", t =>
                        {
                            t.HasCheckConstraint("ck_addresses_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.cities_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "cities_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.Property<long>("RegionId")
                        .HasColumnType("bigint")
                        .HasColumnName("region_id");

                    b.HasKey("Id")
                        .HasName("pk_cities");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_cities_uuid");

                    b.HasIndex("RegionId")
                        .HasDatabaseName("ix_cities_region_id");

                    b.ToTable("cities", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Company", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.companies_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "companies_id_sequence");

                    b.Property<string>("ContactEmail")
                        .IsRequired()
                        .HasColumnType("varchar(256)")
                        .HasColumnName("contact_email");

                    b.Property<string>("ContactPhoneNumber")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("contact_phone_number");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("LegalAddress")
                        .IsRequired()
                        .HasColumnType("varchar(256)")
                        .HasColumnName("legal_address");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_companies");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_companies_uuid");

                    b.ToTable("companies", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Country", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.countries_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "countries_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_countries");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_countries_uuid");

                    b.ToTable("countries", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.regions_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "regions_id_sequence");

                    b.Property<long>("CountryId")
                        .HasColumnType("bigint")
                        .HasColumnName("country_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_regions");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_regions_uuid");

                    b.HasIndex("CountryId")
                        .HasDatabaseName("ix_regions_country_id");

                    b.ToTable("regions", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Route", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.routes_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "routes_id_sequence");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("name");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasColumnType("varchar(16)")
                        .HasColumnName("vehicle_type");

                    b.HasKey("Id")
                        .HasName("pk_routes");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_routes_uuid");

                    b.ToTable("routes", "application", t =>
                        {
                            t.HasCheckConstraint("ck_routes_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddress", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.route_addresses_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "route_addresses_id_sequence");

                    b.Property<long>("AddressId")
                        .HasColumnType("bigint")
                        .HasColumnName("address_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<short>("Order")
                        .HasColumnType("smallint")
                        .HasColumnName("order");

                    b.Property<long>("RouteId")
                        .HasColumnType("bigint")
                        .HasColumnName("route_id");

                    b.HasKey("Id")
                        .HasName("pk_route_addresses");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_route_addresses_uuid");

                    b.HasAlternateKey("AddressId", "RouteId", "Order")
                        .HasName("altk_route_addresses_address_id_route_id_order");

                    b.HasIndex("AddressId")
                        .HasDatabaseName("ix_route_addresses_address_id");

                    b.HasIndex("RouteId")
                        .HasDatabaseName("ix_route_addresses_route_id");

                    b.ToTable("route_addresses", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddressDetail", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.route_address_details_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "route_address_details_id_sequence");

                    b.Property<decimal>("CostToNextAddress")
                        .HasColumnType("numeric(24,12)")
                        .HasColumnName("cost_to_next_address");

                    b.Property<TimeSpan>("CurrentAddressStopTime")
                        .HasColumnType("interval")
                        .HasColumnName("current_address_stop_time");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<long>("RouteAddressId")
                        .HasColumnType("bigint")
                        .HasColumnName("route_address_id");

                    b.Property<TimeSpan>("TimeToNextAddress")
                        .HasColumnType("interval")
                        .HasColumnName("time_to_next_address");

                    b.Property<long>("VehicleEnrollmentId")
                        .HasColumnType("bigint")
                        .HasColumnName("vehicle_enrollment_id");

                    b.HasKey("Id")
                        .HasName("pk_route_address_details");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_route_address_details_uuid");

                    b.HasIndex("RouteAddressId")
                        .HasDatabaseName("ix_route_address_details_route_address_id");

                    b.HasIndex("VehicleEnrollmentId")
                        .HasDatabaseName("ix_route_address_details_vehicle_enrollment_id");

                    b.ToTable("route_address_details", "application");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Vehicle", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.vehicles_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "vehicles_id_sequence");

                    b.Property<long>("CompanyId")
                        .HasColumnType("bigint")
                        .HasColumnName("company_id");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<string>("VehicleType")
                        .IsRequired()
                        .HasColumnType("varchar(16)")
                        .HasColumnName("vehicle_type");

                    b.HasKey("Id")
                        .HasName("pk_vehicles");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_vehicles_uuid");

                    b.HasIndex("CompanyId")
                        .HasDatabaseName("ix_vehicles_company_id");

                    b.ToTable("vehicles", "application", t =>
                        {
                            t.HasCheckConstraint("ck_vehicles_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });

                    b.HasDiscriminator<string>("VehicleType");

                    b.UseTphMappingStrategy();
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.VehicleEnrollment", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id")
                        .HasDefaultValueSql("nextval('application.vehicle_enrollments_id_sequence')");

                    NpgsqlPropertyBuilderExtensions.UseSequence(b.Property<long>("Id"), "vehicle_enrollments_id_sequence");

                    b.Property<string>("Currency")
                        .IsRequired()
                        .HasColumnType("varchar(8)")
                        .HasColumnName("currency");

                    b.Property<DateTimeOffset>("DepartureTime")
                        .HasColumnType("timestamptz")
                        .HasColumnName("departure_time");

                    b.Property<Guid>("Guid")
                        .HasColumnType("uuid")
                        .HasColumnName("uuid");

                    b.Property<long>("RouteId")
                        .HasColumnType("bigint")
                        .HasColumnName("route_id");

                    b.Property<long>("VehicleId")
                        .HasColumnType("bigint")
                        .HasColumnName("vehicle_id");

                    b.HasKey("Id")
                        .HasName("pk_vehicle_enrollments");

                    b.HasAlternateKey("Guid")
                        .HasName("altk_vehicle_enrollments_uuid");

                    b.HasIndex("RouteId")
                        .HasDatabaseName("ix_vehicle_enrollments_route_id");

                    b.HasIndex("VehicleId")
                        .HasDatabaseName("ix_vehicle_enrollments_vehicle_id");

                    b.ToTable("vehicle_enrollments", "application", t =>
                        {
                            t.HasCheckConstraint("ck_vehicle_enrollments_currency", "currency IN ('DEFAULT', 'USD', 'EUR', 'UAH')");
                        });
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Aircraft", b =>
                {
                    b.HasBaseType("cuqmbr.TravelGuide.Domain.Entities.Vehicle");

                    b.Property<short>("Capacity")
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("smallint")
                        .HasColumnName("capacity");

                    b.Property<string>("Model")
                        .IsRequired()
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("model");

                    b.Property<string>("Number")
                        .IsRequired()
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("varchar(32)")
                        .HasColumnName("number");

                    b.ToTable(t =>
                        {
                            t.HasCheckConstraint("ck_vehicles_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });

                    b.HasDiscriminator().HasValue("aircraft");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Bus", b =>
                {
                    b.HasBaseType("cuqmbr.TravelGuide.Domain.Entities.Vehicle");

                    b.Property<short>("Capacity")
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("smallint")
                        .HasColumnName("capacity");

                    b.Property<string>("Model")
                        .IsRequired()
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("model");

                    b.Property<string>("Number")
                        .IsRequired()
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("varchar(32)")
                        .HasColumnName("number");

                    b.ToTable(t =>
                        {
                            t.HasCheckConstraint("ck_vehicles_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });

                    b.HasDiscriminator().HasValue("bus");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Train", b =>
                {
                    b.HasBaseType("cuqmbr.TravelGuide.Domain.Entities.Vehicle");

                    b.Property<short>("Capacity")
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("smallint")
                        .HasColumnName("capacity");

                    b.Property<string>("Model")
                        .IsRequired()
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("varchar(64)")
                        .HasColumnName("model");

                    b.Property<string>("Number")
                        .IsRequired()
                        .ValueGeneratedOnUpdateSometimes()
                        .HasColumnType("varchar(32)")
                        .HasColumnName("number");

                    b.ToTable(t =>
                        {
                            t.HasCheckConstraint("ck_vehicles_vehicle_type", "vehicle_type IN ('bus', 'train', 'aircraft')");
                        });

                    b.HasDiscriminator().HasValue("train");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.City", "City")
                        .WithMany("Addresses")
                        .HasForeignKey("CityId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_addresses_city_id");

                    b.Navigation("City");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Region", "Region")
                        .WithMany("Cities")
                        .HasForeignKey("RegionId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_cities_region_id");

                    b.Navigation("Region");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Country", "Country")
                        .WithMany("Regions")
                        .HasForeignKey("CountryId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_regions_country_id");

                    b.Navigation("Country");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddress", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Address", "Address")
                        .WithMany("AddressRoutes")
                        .HasForeignKey("AddressId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_route_addresses_address_id");

                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Route", "Route")
                        .WithMany("RouteAddresses")
                        .HasForeignKey("RouteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_route_addresses_route_id");

                    b.Navigation("Address");

                    b.Navigation("Route");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddressDetail", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.RouteAddress", "RouteAddress")
                        .WithMany("Details")
                        .HasForeignKey("RouteAddressId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_route_address_details_route_address_id");

                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.VehicleEnrollment", "VehicleEnrollment")
                        .WithMany("RouteAddressDetails")
                        .HasForeignKey("VehicleEnrollmentId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_route_address_details_vehicle_enrollment_id");

                    b.Navigation("RouteAddress");

                    b.Navigation("VehicleEnrollment");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Vehicle", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Company", "Company")
                        .WithMany("Vehicles")
                        .HasForeignKey("CompanyId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_vehicles_company_id");

                    b.Navigation("Company");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.VehicleEnrollment", b =>
                {
                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Route", "Route")
                        .WithMany("VehicleEnrollments")
                        .HasForeignKey("RouteId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_vehicle_enrollments_route_id");

                    b.HasOne("cuqmbr.TravelGuide.Domain.Entities.Vehicle", "Vehicle")
                        .WithMany("Enrollments")
                        .HasForeignKey("VehicleId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_vehicle_enrollments_vehicle_id");

                    b.Navigation("Route");

                    b.Navigation("Vehicle");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Address", b =>
                {
                    b.Navigation("AddressRoutes");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.City", b =>
                {
                    b.Navigation("Addresses");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Company", b =>
                {
                    b.Navigation("Vehicles");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Country", b =>
                {
                    b.Navigation("Regions");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Region", b =>
                {
                    b.Navigation("Cities");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Route", b =>
                {
                    b.Navigation("RouteAddresses");

                    b.Navigation("VehicleEnrollments");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.RouteAddress", b =>
                {
                    b.Navigation("Details");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.Vehicle", b =>
                {
                    b.Navigation("Enrollments");
                });

            modelBuilder.Entity("cuqmbr.TravelGuide.Domain.Entities.VehicleEnrollment", b =>
                {
                    b.Navigation("RouteAddressDetails");
                });
#pragma warning restore 612, 618
        }
    }
}
