﻿using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Add_Companies : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropCheckConstraint(
                name: "ck_vehicle_enrollments_currency",
                schema: "application",
                table: "vehicle_enrollments");

            migrationBuilder.CreateSequence(
                name: "companies_id_sequence",
                schema: "application");

            migrationBuilder.AddColumn<long>(
                name: "company_id",
                schema: "application",
                table: "vehicles",
                type: "bigint",
                nullable: false,
                defaultValue: 0L);

            migrationBuilder.CreateTable(
                name: "companies",
                schema: "application",
                columns: table => new
                {
                    id = table.Column<long>(type: "bigint", nullable: false, defaultValueSql: "nextval('application.companies_id_sequence')"),
                    name = table.Column<string>(type: "varchar(64)", nullable: false),
                    legal_address = table.Column<string>(type: "varchar(256)", nullable: false),
                    contact_email = table.Column<string>(type: "varchar(256)", nullable: false),
                    contact_phone_number = table.Column<string>(type: "varchar(64)", nullable: false),
                    uuid = table.Column<Guid>(type: "uuid", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("pk_companies", x => x.id);
                    table.UniqueConstraint("altk_companies_uuid", x => x.uuid);
                });

            migrationBuilder.CreateIndex(
                name: "ix_vehicles_company_id",
                schema: "application",
                table: "vehicles",
                column: "company_id");

            migrationBuilder.AddCheckConstraint(
                name: "ck_vehicle_enrollments_currency",
                schema: "application",
                table: "vehicle_enrollments",
                sql: "currency IN ('DEFAULT', 'USD', 'EUR', 'UAH')");

            migrationBuilder.AddForeignKey(
                name: "fk_vehicles_company_id",
                schema: "application",
                table: "vehicles",
                column: "company_id",
                principalSchema: "application",
                principalTable: "companies",
                principalColumn: "id",
                onDelete: ReferentialAction.Cascade);
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "fk_vehicles_company_id",
                schema: "application",
                table: "vehicles");

            migrationBuilder.DropTable(
                name: "companies",
                schema: "application");

            migrationBuilder.DropIndex(
                name: "ix_vehicles_company_id",
                schema: "application",
                table: "vehicles");

            migrationBuilder.DropCheckConstraint(
                name: "ck_vehicle_enrollments_currency",
                schema: "application",
                table: "vehicle_enrollments");

            migrationBuilder.DropColumn(
                name: "company_id",
                schema: "application",
                table: "vehicles");

            migrationBuilder.DropSequence(
                name: "companies_id_sequence",
                schema: "application");

            migrationBuilder.AddCheckConstraint(
                name: "ck_vehicle_enrollments_currency",
                schema: "application",
                table: "vehicle_enrollments",
                sql: "currency IN ('USD', 'EUR', 'UAH')");
        }
    }
}
