﻿using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Persistence.PostgreSql.Migrations
{
    /// <inheritdoc />
    public partial class Add_status_to_Ticket_Group : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "returned",
                schema: "application",
                table: "ticket_groups");

            migrationBuilder.AddColumn<string>(
                name: "status",
                schema: "application",
                table: "ticket_groups",
                type: "varchar(32)",
                nullable: false,
                defaultValue: "");

            migrationBuilder.AddCheckConstraint(
                name: "ck_ticket_groups_status",
                schema: "application",
                table: "ticket_groups",
                sql: "status IN ('reserved', 'returned', 'purchased')");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropCheckConstraint(
                name: "ck_ticket_groups_status",
                schema: "application",
                table: "ticket_groups");

            migrationBuilder.DropColumn(
                name: "status",
                schema: "application",
                table: "ticket_groups");

            migrationBuilder.AddColumn<bool>(
                name: "returned",
                schema: "application",
                table: "ticket_groups",
                type: "boolean",
                nullable: false,
                defaultValue: false);
        }
    }
}
